package grm

import (
	"errors"
	"fmt"
	"gitlab.com/revalus/grm/internal/config"
	"os"
	"strings"
)

func getFileContent(pathToFile string) ([]byte, error) {
	return os.ReadFile(pathToFile)
}

func getFileExtension(pathToFile string) (string, error) {
	splitFileName := strings.Split(pathToFile, ".")

	if len(splitFileName) == 1 {
		msg := fmt.Sprintf("excension for file \"%v\", not found", splitFileName)
		return "", errors.New(msg)
	}

	fileExtension := splitFileName[len(splitFileName)-1]

	return fileExtension, nil
}

func checkIsItemInSlice(check string, sliceToCheck []string) bool {
	for _, item := range sliceToCheck {
		if item == check {
			return true
		}
	}

	return false
}

func checkAnyOfItemInSlice(check []string, sliceToCheck []string) bool {

	for _, item := range check {
		if checkIsItemInSlice(item, sliceToCheck) {
			return true
		}
	}

	return false
}

func reverseRepositoryConfigs(repositories []config.RepositoryConfig) []config.RepositoryConfig {
	for i, j := 0, len(repositories)-1; i < j; i, j = i+1, j-1 {
		repositories[i], repositories[j] = repositories[j], repositories[i]
	}
	return repositories
}
